/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.database.Cursor;
import android.util.Log;

import net.micode.notes.tool.GTaskStringUtils;

import org.json.JSONException;
import org.json.JSONObject;

//MetaData类用于管理笔记的元数据信息
public class MetaData extends Task {

    //类的简单名称，用于日志输出
    private final static String TAG = MetaData.class.getSimpleName();

    //相关联的Google任务ID
    private String mRelatedGid = null;

    //设置元数据信息
    public void setMeta(String gid, JSONObject metaInfo) {
        try {
            //将相关联的Google任务ID放入元数据信息中
            metaInfo.put(GTaskStringUtils.META_HEAD_GTASK_ID, gid);
        } catch (JSONException e) {
            //如果放入失败，记录错误日志
            Log.e(TAG, "failed to put related gid");
        }
        //设置笔记的元数据信息
        setNotes(metaInfo.toString());
        //设置笔记名称
        setName(GTaskStringUtils.META_NOTE_NAME);
    }

    //获取相关联的Google任务ID
    public String getRelatedGid() {
        return mRelatedGid;
    }

    //检查笔记是否值得保存
    @Override
    public boolean isWorthSaving() {
        //如果笔记有元数据信息，则值得保存
        return getNotes() != null;
    }

    //根据远程JSON内容设置笔记的内容
    @Override
    public void setContentByRemoteJSON(JSONObject js) {
        super.setContentByRemoteJSON(js);
        if (getNotes() != null) {
            try {
                //从笔记的元数据信息中获取相关连的Google任务ID
                JSONObject metaInfo = new JSONObject(getNotes().trim());
                mRelatedGid = metaInfo.getString(GTaskStringUtils.META_HEAD_GTASK_ID);
            } catch (JSONException e) {
                //如果获取失败。记录警告日志
                Log.w(TAG, "failed to get related gid");
                mRelatedGid = null;
            }
        }
    }

    //下面的方法不应该被调用，因此抛出IllegalAccessError异常
    @Override
    public void setContentByLocalJSON(JSONObject js) {
        // this function should not be called
        throw new IllegalAccessError("MetaData:setContentByLocalJSON should not be called");
    }

    @Override
    public JSONObject getLocalJSONFromContent() {
        throw new IllegalAccessError("MetaData:getLocalJSONFromContent should not be called");
    }

    @Override
    public int getSyncAction(Cursor c) {
        throw new IllegalAccessError("MetaData:getSyncAction should not be called");
    }

}
